#version 130

//Implied in variables: gl_Vertex, gl_Normal, gl_MultiTexCoord0, gl_MultiTexCoord1, gl_Color
//Matrices available:  gl_ModelViewMatrix, gl_ProjectionMatrix
//Goal of pixel shader: 
//	1. To receive information from vertex shader.
//	2. To compute final pixel color

//The globals
//uniform float brightNess; //For use by the vertex shader
uniform sampler2D texture; //For use by the pixel shader

//The information passed along. Note: smooth is default rather than noperspective or flat
in vec2 textureCoordinate; 
in vec4 pixelColor;

out vec4 finalColor; //Or special built-in variable gl_FragColor 

void main () {
	vec4 textureColor = texture2D (texture, textureCoordinate);
	finalColor = textureColor * pixelColor;
}
