#version 130

//Implied in variables: gl_Vertex, gl_Normal, gl_MultiTexCoord0, gl_MultiTexCoord1, gl_Color
//Matrices available:  gl_ModelViewMatrix, gl_ProjectionMatrix
//Goal of vertex shader: 
//	1. To compute gl_Position in projection coordinates.
//	2. To pass along information needed by pixel shader; e.g., texure coordinates and color

//The globals
uniform float brightness; //For use by the vertex shader
//uniform mat4 unused; //But WHAT IF we wanted to use it
//uniform sampler2D texture; //For use by the pixel shader

//The information passed along. Note: smooth is default rather than noperspective or flat
out vec2 textureCoordinate; 
out vec4 pixelColor;

void main () {
	textureCoordinate = gl_MultiTexCoord0.xy; //From vec4 to vec2
	gl_Position = gl_ProjectionMatrix * (gl_ModelViewMatrix * gl_Vertex);
	pixelColor = vec4 (gl_Color.xyz * brightness, gl_Color.a);
}


