#version 130

uniform vec3 lightDirection;

out vec3 lightDirectionInCameraSpace;
out vec3 normalInCameraSpace;

out vec2 textureCoordinate; 
out vec4 pixelColor;

void main () {
	//Convert the normal to camera space and pass along 
	//with the camera light direction also in camera space.
	mat3 rotationOnly = mat3 (gl_ModelViewMatrix);
	lightDirectionInCameraSpace = normalize (lightDirection);
	normalInCameraSpace = normalize (rotationOnly * gl_Normal); //Should use inverse transpose...

	textureCoordinate = gl_MultiTexCoord0.xy; //From vec4 to vec2
	gl_Position = gl_ProjectionMatrix * (gl_ModelViewMatrix * gl_Vertex);
	pixelColor = gl_Color;
}


